from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Int, Boolean

Findhicdomains_Pl_V0_1_0 = CommandToolBuilder(tool="findHiCDomains.pl", base_command=["findHiCDomains.pl"], inputs=[ToolInput(tag="in_or", input_type=Int(optional=True), prefix="-or-", doc=InputDocumentation(doc="<output prefix> <directionality index bedgraph> [options]\n(Use the 2nd usage to change parameters for domain calls after running)")), ToolInput(tag="in_res", input_type=Boolean(optional=True), prefix="-res", doc=InputDocumentation(doc="<#> (resolution in bp, default: 5000)")), ToolInput(tag="in_window", input_type=Boolean(optional=True), prefix="-window", doc=InputDocumentation(doc="<#> (window resolution in bp, i.e. superRes, default: 25000)")), ToolInput(tag="in_max_dist", input_type=Boolean(optional=True), prefix="-maxDist", doc=InputDocumentation(doc="<#> (max distance from loci to check direction index, default: 1000000)")), ToolInput(tag="in_mind_ist", input_type=Boolean(optional=True), prefix="-minDist", doc=InputDocumentation(doc="<#> (minimum distance from loci to check direction index, default: 0)")), ToolInput(tag="in_log", input_type=Boolean(optional=True), prefix="-log", doc=InputDocumentation(doc="(score direction index with log ratios, default: use linear ratios)")), ToolInput(tag="in_std", input_type=Boolean(optional=True), prefix="-std", doc=InputDocumentation(doc="<#> (exclude regions with sequencing depth exceeding # std deviations, default: 8)")), ToolInput(tag="in_min", input_type=Boolean(optional=True), prefix="-min", doc=InputDocumentation(doc="<#> (exclude regions with sequencing depth less than this fraction of mean, default: 0.05)")), ToolInput(tag="in_cpu", input_type=Boolean(optional=True), prefix="-cpu", doc=InputDocumentation(doc="<#> (number of CPUs to use, default: 1)")), ToolInput(tag="in_min_index", input_type=Boolean(optional=True), prefix="-minIndex", doc=InputDocumentation(doc="<#> (minimum index score to be considered for boundary (as zscore), default: 0.5)")), ToolInput(tag="in_mine_xp_index", input_type=Boolean(optional=True), prefix="-minExpIndex", doc=InputDocumentation(doc="<#> (minimum index score to be considered for boundary (as zscore), default: 1e-05)")), ToolInput(tag="in_min_delta", input_type=Boolean(optional=True), prefix="-minDelta", doc=InputDocumentation(doc="<#> (minimum change in dir-index between boundaries (as zscore), default: 1)")), ToolInput(tag="in_minlength", input_type=Boolean(optional=True), prefix="-minLength", doc=InputDocumentation(doc="<#> (minimum domain length, default: 25000)")), ToolInput(tag="in_max_error", input_type=Boolean(optional=True), prefix="-maxError", doc=InputDocumentation(doc="<#> (maximum variation in directionality index within domain, default: 0.25)"))], outputs=[], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Findhicdomains_Pl_V0_1_0().translate("wdl", allow_empty_container=True)

